PT-DEADLOCK-LOGGER(1p)

NAME
pt-deadlock-logger - Log MySQL deadlocks.

SYNOPSIS
Usage: pt-deadlock-logger [OPTIONS] DSN

pt-deadlock-logger logs information about MySQL deadlocks on the given DSN. Information is printed to "STDOUT", and it can also be saved to a table by specifying "--dest". The tool runs for forever unless "--run-time" or "--iterations" is specified.

Print deadlocks on host1:

   pt-deadlock-logger h=host1

Print deadlocks on host1 once then exit:

   pt-deadlock-logger h=host1 --iterations 1

Save deadlocks on host1 to percona_schema.deadlocks on host2:

  pt-deadlock-logger h=host1 --dest h=host2,D=percona_schema,t=deadlocks

RISKS
Percona Toolkit is mature, proven in the real world, and well tested, but all database tools can pose a risk to the system and the database server. Before using this tool, please:

•   Read the tool's documentation

•   Review the tool's known "BUGS"

•   Test the tool on a non-production server

•   Backup your production server and verify the backups

DESCRIPTION
pt-deadlock-logger prints information about MySQL deadlocks by polling and parsing "SHOW ENGINE INNODB STATUS". When a new deadlock occurs, it's printed to "STDOUT" and, if specified, saved to "--dest".

Only new deadlocks are printed. A fingerprint for each deadlock is created using the deadlock's server, ts, and thread values (even if these columns are not specified by "--columns"). A deadlock is printed if its fingerprint is different than the last deadlock's fingerprint.

The "--dest" statement uses "INSERT IGNORE" to eliminate duplicate deadlocks, so every deadlock is saved for every "--iterations".

OUTPUT
New deadlocks are printed to "STDOUT", unless "--quiet" is specified. Errors and warnings are printed to "STDERR".

See also "--columns" and "--tab".

INNODB CAVEATS AND DETAILS
InnoDB's output is hard to parse and sometimes there's no way to do it right.

Sometimes not all information (for example, username or IP address) is included in the deadlock information. In this case there's nothing for the tool to put in those columns. It may also be the case that the deadlock output is so long (because there were a lot of locks) that the whole thing is truncated.

Though there are usually two transactions involved in a deadlock, there are more locks than that; at a minimum, one more lock than transactions is necessary to create a cycle in the waits-for graph. pt-deadlock-logger prints the transactions (always two in the InnoDB output, even when there are more transactions in the waits-for graph than that) and fills in locks. It prefers waited-for over held when choosing lock information to output, but you can figure out the rest with a moment's thought. If you see one wait-for and one held lock, you're looking at the same lock, so of course you'd prefer to see both wait-for locks and get more information. If the two waited-for locks are not on the same table, more than two transactions were involved in the deadlock.

Finally, keep in mind that, because usernames with spaces are not quoted by InnoDB, the tool will generally misreport the second word of these usernames as the hostname.

OPTIONS
This tool accepts additional command-line arguments. Refer to the "SYNOPSIS" and usage information for details.

--ask-pass
    Prompt for a password when connecting to MySQL.

--charset
    short form: -A; type: string

    Default character set. If the value is utf8, sets Perl's binmode on STDOUT to utf8, passes the mysql_enable_utf8 option to DBD::mysql, and runs SET NAMES UTF8 after connecting to MySQL. Any other value sets binmode on STDOUT without the utf8 layer, and runs SET NAMES after connecting to MySQL.

--clear-deadlocks
    type: string

    Use this table to create a small deadlock. This usually has the effect of clearing out a huge deadlock, which otherwise consumes the entire output of "SHOW INNODB STATUS". The table must not exist. pt-deadlock-logger will create it with the following structure:

      CREATE TABLE percona_schema.clear_deadlocks (
        a INT PRIMARY KEY
      ) ENGINE=InnoDB

    After creating the table and causing a small deadlock, the tool will drop the table again.

--columns
    type: Array; default: server, ts, thread, txn_id, txn_time, user, hostname, ip, db, tbl, idx, lock_type, lock_mode, wait_hold, victim, query

    The columns are:

    server
        The (source) server on which the deadlock occurred. This might be useful if you're tracking deadlocks on many servers.

    ts  The date and time of the last detected deadlock.

    thread
        The MySQL thread number, which is the same as the connection ID in SHOW FULL PROCESSLIST.

    txn_id
        The InnoDB transaction ID, which InnoDB expresses as two unsigned integers. I have multiplied them out to be one number.

    txn_time
        How long the transaction was active when the deadlock happened.

    user
        The connection's database username.

    hostname
        The connection's host.

    ip  The connection's IP address. If you specify "--numeric-ip", this is converted to an unsigned integer.

    db  The database in which the deadlock occurred.

    tbl The table on which the deadlock occurred.

    idx The index on which the deadlock occurred.

    lock_type
        The lock type the transaction held on the lock that caused the deadlock.

    lock_mode
        The lock mode of the lock that caused the deadlock.

    wait_hold
        Whether the transaction was waiting for the lock or holding the lock. Usually you will see the two waited-for locks.

    victim
        Whether the transaction was selected as the deadlock victim and rolled back.

    query
        The query that caused the deadlock.

--config
    type: Array

    Read this comma-separated list of config files; if specified, this must be the first option on the command line.

--create-dest-table
    Create the table specified by "--dest".

    Normally the "--dest" table is expected to exist already. This option causes pt-deadlock-logger to create the table automatically using the suggested table structure.

--daemonize
    Fork to the background and detach from the shell. POSIX operating systems only.

--database
    short form: -D; type: string

    Connect to this database.

--defaults-file
    short form: -F; type: string

    Only read mysql options from the given file. You must give an absolute pathname.

--dest
    type: DSN

    DSN for where to store deadlocks; specify at least a database (D) and table (t).

    Missing values are filled in with the same values from the source host, so you can usually omit most parts of this argument if you're storing deadlocks on the same server on which they happen.

    The following table structure is suggested if you want to store all the information pt-deadlock-logger can extract about deadlocks:

     CREATE TABLE deadlocks (
       server char(20) NOT NULL,
       ts timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
       thread int unsigned NOT NULL,
       txn_id bigint unsigned NOT NULL,
       txn_time smallint unsigned NOT NULL,
       user char(16) NOT NULL,
       hostname char(20) NOT NULL,
       ip char(15) NOT NULL, -- alternatively, ip int unsigned NOT NULL
       db char(64) NOT NULL,
       tbl char(64) NOT NULL,
       idx char(64) NOT NULL,
       lock_type char(16) NOT NULL,
       lock_mode char(1) NOT NULL,
       wait_hold char(1) NOT NULL,
       victim tinyint unsigned NOT NULL,
       query text NOT NULL,
       PRIMARY KEY  (server,ts,thread)
     ) ENGINE=InnoDB

    If you use "--columns", you can omit whichever columns you don't want to store.

--help
    Show help and exit.

--host
    short form: -h; type: string

    Connect to host.

--interval
    type: time; default: 30

    How often to check for deadlocks. If no "--run-time" is specified, pt-deadlock-logger runs forever, checking for deadlocks at every interval. See also "--run-time".

--iterations
    type: int

    How many times to check for deadlocks. By default, this option is undefined which means an infinite number of iterations. The tool always exits for "--run-time", regardless of the value specified for this option. For example, the tool will exit after 1 minute with "--run-time 1m --iterations 4 --interval 30" because 4 iterations at 30 second intervals would take 2 minutes, longer than the 1 mintue run-time.

--log
    type: string

    Print all output to this file when daemonized.

--numeric-ip
    Express IP addresses as integers.

--password
    short form: -p; type: string

    Password to use when connecting. If password contains commas they must be escaped with a backslash: "exam\,ple"

--pid
    type: string

    Create the given PID file. The tool won't start if the PID file already exists and the PID it contains is different than the current PID. However, if the PID file exists and the PID it contains is no longer running, the tool will overwrite the PID file with the current PID. The PID file is removed automatically when the tool exits.

--port
    short form: -P; type: int

    Port number to use for connection.

--quiet
    Do not deadlocks; only print errors and warnings to "STDERR".

--run-time
    type: time

    How long to run before exiting. By default pt-deadlock-logger runs forever, checking for deadlocks every "--interval" seconds.

--set-vars
    type: Array

    Set the MySQL variables in this comma-separated list of "variable=value" pairs.

    By default, the tool sets:

       wait_timeout=10000

    Variables specified on the command line override these defaults. For example, specifying "--set-vars wait_timeout=500" overrides the defaultvalue of 10000.

    The tool prints a warning and continues if a variable cannot be set.

--socket
    short form: -S; type: string

    Socket file to use for connection.

--tab
    Use tabs to separate columns instead of spaces.

--user
    short form: -u; type: string

    User for login if not current user.

--version
    Show version and exit.

--[no]version-check
    default: yes

    Check for the latest version of Percona Toolkit, MySQL, and other programs.

    This is a standard "check for updates automatically" feature, with two additional features. First, the tool checks its own version and also the versions of the following software: operating system, Percona Monitoring and Management (PMM), MySQL, Perl, MySQL driver for Perl (DBD::mysql), and Percona Toolkit. Second, it checks for and warns about versions with known problems. For example, MySQL 5.5.25 had a critical bug and was re-released as 5.5.25a.

    A secure connection to Percona’s Version Check database server is done to perform these checks. Each request is logged by the server, including software version numbers and unique ID of the checked system. The ID is generated by the Percona Toolkit installation script or when the Version Check database call is done for the first time.

    Any updates or known problems are printed to STDOUT before the tool's normal output. This feature should never interfere with the normal operation of the tool.

    For more information, visit <https://www.percona.com/doc/percona-toolkit/LATEST/version-check.html>.

DSN OPTIONS
These DSN options are used to create a DSN. Each option is given like "option=value". The options are case-sensitive, so P and p are not the same option. There cannot be whitespace before or after the "=" and if the value contains whitespace it must be quoted. DSN options are comma-separated. See the percona-toolkit manpage for full details.

•   A

    dsn: charset; copy: yes

    Default character set.

•   D

    dsn: database; copy: yes

    Default database.

•   F

    dsn: mysql_read_default_file; copy: yes

    Only read default options from the given file

•   h

    dsn: host; copy: yes

    Connect to host.

•   p

    dsn: password; copy: yes

    Password to use when connecting. If password contains commas they must be escaped with a backslash: "exam\,ple"

•   P

    dsn: port; copy: yes

    Port number to use for connection.

•   S

    dsn: mysql_socket; copy: yes

    Socket file to use for connection.

•   t

    Table in which to store deadlock information.

•   u

    dsn: user; copy: yes

    User for login if not current user.

ENVIRONMENT
The environment variable "PTDEBUG" enables verbose debugging output to STDERR. To enable debugging and capture all output to a file, run the tool like:

   PTDEBUG=1 pt-deadlock-logger ... > FILE 2>&1

Be careful: debugging output is voluminous and can generate several megabytes of output.

SYSTEM REQUIREMENTS
You need Perl, DBI, DBD::mysql, and some core packages that ought to be installed in any reasonably new version of Perl.

BUGS
For a list of known bugs, see <http://www.percona.com/bugs/pt-deadlock-logger>.

Please report bugs at <https://jira.percona.com/projects/PT>. Include the following information in your bug report:

•   Complete command-line used to run the tool

•   Tool "--version"

•   MySQL version of all servers involved

•   Output from the tool including STDERR

•   Input files (log/dump/config files, etc.)

If possible, include debugging output by running the tool with "PTDEBUG"; see "ENVIRONMENT".

DOWNLOADING
Visit <http://www.percona.com/software/percona-toolkit/> to download the latest release of Percona Toolkit. Or, get the latest release from the command line:

   wget percona.com/get/percona-toolkit.tar.gz

   wget percona.com/get/percona-toolkit.rpm

   wget percona.com/get/percona-toolkit.deb

You can also get individual tools from the latest release:

   wget percona.com/get/TOOL

Replace "TOOL" with the name of any tool.

AUTHORS
Baron Schwartz and Daniel Nichter

ABOUT PERCONA TOOLKIT
This tool is part of Percona Toolkit, a collection of advanced command-line tools for MySQL developed by Percona. Percona Toolkit was forked from two projects in June, 2011: Maatkit and Aspersa. Those projects were created by Baron Schwartz and primarily developed by him and Daniel Nichter. Visit <http://www.percona.com/software/> to learn about other free, open-source software from Percona.

COPYRIGHT, LICENSE, AND WARRANTY
This program is copyright 2011-2018 Percona LLC and/or its affiliates, 2007-2011 Baron Schwartz.

THIS PROGRAM IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.

This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, version 2; OR the Perl Artistic License. On UNIX and similar systems, you can issue `man perlgpl' or `man perlartistic' to read these licenses.

You should have received a copy of the GNU General Public License along with this program; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.

VERSION
pt-deadlock-logger 3.1.0

POD ERRORS
Hey! The above document had some coding errors, which are explained below:

Around line 5513:
    Non-ASCII character seen before =encoding in 'Percona’s'. Assuming UTF-8